package grafy;

import java.util.ArrayDeque;

public class AlgorytmBFS{
	
	private boolean[] odwiedzone;
	private int[] rodzice;
	private int ile=0;
	private int start;
	
	/**
	 * 	
	 * @param G
	 * @param s
	 */
	public AlgorytmBFS(Graf G, int s)
	{
		odwiedzone=new boolean[G.n()];
		rodzice=new int[G.n()];
		this.start=s;
		bfs(G,start);
	}
	
	
	private void bfs(Graf G, int v)
	{	
		ArrayDeque<Integer> kolejka= new ArrayDeque<Integer>();
		kolejka.add(v);	
		ile++;
		odwiedzone[v]=true;
		while (!kolejka.isEmpty())
		{
			int pierwszy = kolejka.poll();
			for (int i:G.sasiedzi(pierwszy))
				if(!odwiedzone[i])
				{
					ile++;
					odwiedzone[i]=true;
					rodzice[i]= pierwszy;
					kolejka.add(i);
				}
		}
	}
	
	/**
	 * 
	 * @return liczba wierzcholkw w skadowej wierzchoka startowego
	 */
	public int ileW()
	{
		return ile;
	}

	/**
	 * 
	 * @param v dany wierzchoek
	 * @return true, jeeli v jest w skadowej wierzchoka startowego
	 */
	public boolean czyOdwiedzony(int v)
	{
		return odwiedzone[v];
	}
	
	/**
	 * 	
	 * @param v dany wierzchoek
	 * @return poprzednik (rodzic) v w drzewie BFS
	 */
	public int rodzic(int v)
	{
		if(v!=start)
			return rodzice[v];
		else throw new IllegalArgumentException("wierzchoek startowy nie ma rodzica");
	}
	
	/**
	 * 
	 * @param v dany wierzchoek
	 * @return BFS-droga z wierzchoka startowego do v
	 */
	public ArrayDeque<Integer> sciezkaDo(int v)
	{
		 if(!czyOdwiedzony(v)) return null;
		 else
		 {
			 ArrayDeque<Integer> sciezka= new ArrayDeque<Integer>();
			 sciezka.push(v);
			 while(v!=start){
				sciezka.push(rodzice[v]);
				v=rodzice[v];			 
			 }
		return sciezka;
		 }	 
	}
}
