package grafy;


public class AlgorytmDFS{
	
	private boolean[] odwiedzone;
	private int ile=0;
	
	/**
	 * Wyznacza zbir wierzchokw grafu G
     * poczonych z wierzchokiem startowym s
     * algorytmem DFS
	 * @param G graf 
	 * @param s wierzchoek grafu G, bdcy wierzchokiem startowym
	 */
	public AlgorytmDFS(Graf G, int s)
	{
		odwiedzone=new boolean[G.n()];
		dfs(G,s);		
	}
	
	//DFS z wierzchoka v
	private void dfs(Graf G, int v)
	{
		odwiedzone[v]=true;
		ile++;
		for(int u:G.sasiedzi(v))
			if(!odwiedzone[u]) dfs(G,u);
	}
	
	/**
	 * zwraca liczb wierzchokw poczonych z wierzchokiem startowym s
	 * @return liczba wierzchokw poczonych z s
	 */
	public int ileW()
	{
		return ile;
	}

	/**
	 * sprawdza, czy wierzchoek v jest poczony z wierzchokiem startowym s
	 * @param v wierzchoek grafu
	 * @return true jeeli istnieje droga v-s, false w przeciwnym przypadku
	 */
	public boolean czyOdwiedzony(int v)
	{
		return odwiedzone[v];
	}
		
}
